const RESERVATION_TOGGLER = 'RESERVATION_TOGGLER'
const SET_SELECTED_DATE_INDEX = 'SET_SELECTED_DATE_INDEX'
const SET_SELECTED_TIME_INDEX = 'SET_SELECTED_TIME_INDEX'


const getPastDatesArray = (period) => (Array.from({ length: period }, (val, i) => (new Date(Date.now() - i * (24 * 60 * 60 * 1000)).toLocaleDateString())))
const getWillDatesArray = (period) => (Array.from({ length: period }, (val, i) => (new Date(Date.now() + i * (24 * 60 * 60 * 1000)).toLocaleDateString())))
const DateArray = [...getPastDatesArray(7).reverse(), ...getWillDatesArray(8).splice(1, 7)]

let initialState = {


    dateSelect: DateArray,
    currentDate: DateArray[6],
    timeSelect: [
        { time: '10:00' }, { time: '12:00' }, { time: '14:00' },
        { time: '16:00' }, { time: '18:00' }, { time: '20:00' }
    ],

    selectedDateIndex: 6,
    selectedTimeIndex: 0,

    seats: [
        {
            date: null,
            time: null,
            id: 1,
            reserved: false
        },
        {
            date: null,
            time: null,
            id: 2,
            reserved: false
        },
        {
            date: null,
            time: null,
            id: 3,
            reserved: false
        },
        {
            date: null,
            time: null,
            id: 4,
            reserved: false
        },
        {
            date: null,
            time: null,
            id: 5,
            reserved: false
        },
        {
            date: null,
            time: null,
            id: 6,
            reserved: false
        },
    ]
}



const reduser = (state = initialState, action) => {

    switch (action.type) {
        case RESERVATION_TOGGLER:
            return {
                ...state,
                seats: state.seats.map(p => {
                    if (p.id === action.id) {
                        return { ...p, reserved: !p.reserved }
                    }
                    return p

                })
            }
        case SET_SELECTED_DATE_INDEX:

            return {
                ...state,
                selectedDateIndex: action.index,
                seats: state.seats.map(s => {
                    return { ...s, date: action.index }
                })


            }
        case SET_SELECTED_TIME_INDEX:
            return {
                ...state,
                selectedTimeIndex: action.index,
                seats: state.seats.map(s => {
                    return { ...s, time: action.index }
                })
            }

        default:
            return state
    }
}

export const reservedTogglerAC = (id) => ({ type: RESERVATION_TOGGLER, id })
export const setSelectedDateIndexAC = (index) => ({ type: SET_SELECTED_DATE_INDEX, index })
export const setSelectedTimeIndexAC = (index) => ({ type: SET_SELECTED_TIME_INDEX, index })

export default reduser